import 'package:equatable/equatable.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import 'src/error_page.dart';
import 'src/route_type.dart';

class CustomRoute extends Equatable {
  RouteType routeType;
  RoutePageBuilder pageBuilder;
  RouteTransitionsBuilder transitions;
  Duration duration;
  bool opaque, barrierDismissible;
  Color barrierColor;
  String barrierLabel, title;

  final String routeName;
  final WidgetBuilder builder;
  final RouteSettings settings;
  final bool maintainState, fullscreenDialog;

  // CustomRoute._({
  //   @required this.routeName,
  //   @required this.builder,
  //   this.settings,
  //   this.maintainState = false,
  //   this.fullscreenDialog = false,
  // }) : assert(routeName != "/");

  CustomRoute({
    @required this.routeName,
    @required this.builder,
    this.settings,
    this.maintainState = false,
    this.fullscreenDialog = false,
  }) : assert(routeName != "/");

  void withTransition({
    //Transition bu,
    RoutePageBuilder pageBuilder,
    @required RouteTransitionsBuilder transitions,
    Duration duration = const Duration(seconds: 1),
    bool opaque = true,
    bool barrierDismissible = false,
    Color barrierColor,
    String barrierLabel,
  }) {
    this.routeType = RouteType.CUSTOM;
    this.pageBuilder = pageBuilder;
    this.transitions = transitions;
    this.duration = duration;
    this.opaque = opaque;
    this.barrierDismissible = barrierDismissible;
    this.barrierColor = barrierColor;
    this.barrierLabel = barrierLabel;
  }

  void byMaterial() {
    routeType = RouteType.MATERIAL;
  }

  void byCupertino(String title) {
    this.title = title;
    routeType = RouteType.CUPERTINO;
  }

  @override
  // TODO: implement props
  List<Object> get props => [
        this.routeType,
        this.pageBuilder,
        this.transitions,
        this.duration,
        this.opaque,
        this.barrierDismissible,
        this.barrierColor,
        this.barrierLabel,
        this.builder,
        this.settings,
        this.maintainState,
        this.fullscreenDialog,
      ];
}
